#include <owl\applicat.h>
#include <owl\framewin.h>
#include <owl\menu.h>
#include "pr17_1.rc"

// 
class TApp: public TApplication
{
  public:
	 TApp():TApplication(){}
	 void InitMainWindow();
};

//  
class TWndw:public TFrameWindow
{
  public:
	 TWndw(TWindow *parent, const char far *title);
  protected:
	 TMenu *menu, *subMenu;
	 BOOL haveItem, fitMoreItems;

	 void SetupWindow();
	 void CleanupWindow();
	 void EvRButtonDown(UINT, TPoint &point);
	 void CmAddItem();
	 void CmAddPopup();
	 void CmDeleteItem();
	 void CmDeletePopup();
	 void CmCheck() ;

	 //   .
	 void CmEnableAddItem (TCommandEnabler &commandEnabler);
	 void CmEnableAddPopup (TCommandEnabler &commandEnabler);
	 void CmEnableDeleteItem (TCommandEnabler &commandEnabler);
	 void CmEnableDeletePopup (TCommandEnabler &commandEnabler);

	 DECLARE_RESPONSE_TABLE (TWndw);
};

DEFINE_RESPONSE_TABLE1 (TWndw, TFrameWindow)
  EV_WM_RBUTTONDOWN,

  EV_COMMAND(CM_ADDITEM,CmAddItem),
  EV_COMMAND(CM_ADDPOPUP,CmAddPopup),
  EV_COMMAND(CM_DELETEITEM,CmDeleteItem),
  EV_COMMAND(CM_DELETEPOPUP,CmDeletePopup),
  EV_COMMAND(CM_CHECK,CmCheck),

  EV_COMMAND_ENABLE(CM_ADDITEM,CmEnableAddItem),
  EV_COMMAND_ENABLE(CM_ADDPOPUP,CmEnableAddPopup),
  EV_COMMAND_ENABLE(CM_DELETEITEM,CmEnableDeleteItem),
  EV_COMMAND_ENABLE(CM_DELETEPOPUP,CmEnableDeletePopup),
END_RESPONSE_TABLE;


TWndw::TWndw(TWindow *parent, const char far *title):
		  TFrameWindow(parent,title)
{
	//     .
	AssignMenu("MENU_1");
	//     .
	Attr.X=50;
	Attr.Y=50;
	Attr.W=GetSystemMetrics(SM_CXSCREEN)/4;
	Attr.H=GetSystemMetrics(SM_CXSCREEN)/5;
}

// TWndw::SetupWindow()
//      SetupWindow()
//  TFrameWindow       
//   . SetupWindow()    
//   ,    .
void TWndw::SetupWindow()
{
  //      .
  menu = new TMenu(HWindow) ;
  //   . 
  subMenu = NULL;
  //  .
  haveItem = FALSE;
  fitMoreItems = TRUE;
}

// TWndw::CleanupWindow()
//      CleanupWindow().
//      
//   .
void TWndw::CleanupWindow()
{
  delete menu;
  if (subMenu)   delete subMenu;
}

// TWndw::EvRButtonDown()
//      WM_RBUTTONDOWN,
//  -   
//  .
void TWndw::EvRButtonDown(UINT, TPoint &point)
{
  //    Test.
  HMENU hMenu = menu->GetSubMenu(1);
  //   TPopupMenu   Test.
  TPopupMenu(hMenu).TrackPopupMenu(0, point.x, point.y, 0, HWindow, 0);
}

// TWndw::CmAddItem()
//       CM_ADDITEM,
//     - .
void TWndw::CmAddItem()
{
  //    Test.
  HMENU hMENU = menu->GetSubMenu(1);
  //   TMenu   Test.
  TMenu sMenu(hMENU);
  //      Test.
  int count = sMenu.GetMenuItemCount();
  //     10 ...
  if (count<10)
  {
	  //     .
	  sMenu.AppendMenu(MF_STRING,CM_ITEM_ID,"New Item");
	  //    ,    ...
	  if(count==9) fitMoreItems=FALSE;
	  // ,     .
		haveItem=TRUE;
	}
}

// TWndw::CmAddPopup()
//       CM_ADDPOPUP,
//       .
void TWndw::CmAddPopup()
{
 //       ...
 if(!subMenu)
  {
	 //   TPopupMenu    .
	 subMenu=new TPopupMenu();
	 //      .
	 subMenu->AppendMenu(MF_STRING,CM_ITEM_ID,"New Item");
	 //       .
	 menu->AppendMenu(MF_POPUP,(UINT)(HMENU)*subMenu,"New Popup");
	 //    .
	 DrawMenuBar();
  }
}

// TWndw::CmDeleteItem()
//      CM_DELETEITEM,
//      Test.
void TWndw::CmDeleteItem()
{
  //     Test.
  HMENU hMenu=menu->GetSubMenu(1);
  //   TMenu    Test.
  TMenu sMenu(hMenu);
  //       Test.
  int count=sMenu.GetMenuItemCount();
  //       ...
  if(count>5)
	{
	  //    .
	  sMenu.DeleteMenu(count-1,MF_BYPOSITION);
	  // ,       .
	  fitMoreItems=TRUE;
	  //    ,    ...
	  if (count-1==5)
			//...,       .
			haveItem=FALSE;
	}
}

// TWndw::CmDeletePopup()
//      CM_DELETEPOPUP,
//    ,   .
void TWndw::CmDeletePopup()
{
	//     ...
	if(subMenu)
	{
	  //   .
	  menu->DeleteMenu(2,MF_BYPOSITION);
	  //   TMenu.
	  delete subMenu;
	  //   .
	  DrawMenuBar();
	  // ,      .
	  subMenu=NULL;
	}
}

// TWndw::CmCheck()
//      CM_CHECK,
//        Test/Check.
void TWndw::CmCheck()
 {
	//      .
	int state=menu->GetMenuState(CM_CHECK,MF_BYCOMMAND);
	//     ...
	if (state == MF_UNCHECKED)
	{
	  //   Uncheck.
	  menu->ModifyMenu(CM_CHECK,MF_STRING,CM_CHECK, "&UnCheck");
	  //      .
	  menu->CheckMenuItem(CM_CHECK,MF_CHECKED);
	}
	else //,    ...
	{
	  //   Check.
	  menu->ModifyMenu(CM_CHECK,MF_STRING,CM_CHECK, "&Check");
	  //  .
	  menu->CheckMenuItem(CM_CHECK,MF_UNCHECKED);
	}
}

// TWndw::CmEnableAddItem()
//     
//     Test/Add  ,  
//   ,   ,
//        .
void TWndw::CmEnableAddItem(TCommandEnabler &commandEnabler)
{
	commandEnabler.Enable(fitMoreItems);
}

// TWndw::CmEnableAddPopup()
//     
//     Test/Add  ,
//     , 
//  ,     .
void TWndw::CmEnableAddPopup(TCommandEnabler &commandEnabler)
{
	commandEnabler.Enable(!subMenu);
}

// TWndw::CmEnableDeleteItem()
//     
//     Test/Delete  ,
//     ,   ,
//    ,   .
void TWndw::CmEnableDeleteItem(TCommandEnabler &commandEnabler)
{
	commandEnabler.Enable(haveItem);
}

// TWndw::CmEnableDeletePopup()
//     
//     Test/Delete 
// ,     ,
//   ,   .
void TWndw::CmEnableDeletePopup(TCommandEnabler &commandEnabler)
{
	commandEnabler.Enable((int)subMenu);
}


void TApp::InitMainWindow()
{
  TFrameWindow *wndw=new TWndw(0,"- ");
  SetMainWindow(wndw);
}

int OwlMain(int,char *[])
{
  return TApp().Run();
}
